import floppyforms as forms
from registration.forms import RegistrationForm
from models import *
from registration.models import RegistrationProfile
import json

class ItfRegistrationForm(RegistrationForm):
    subscribe = forms.BooleanField(help_text='Subscribe to newsletter?')

    def save(self, profile_callback=None):
        new_user = RegistrationProfile.objects.create_inactive_user(username=self.cleaned_data['username'], password=self.cleaned_data['password1'], email=self.cleaned_data['email'])
        new_profile = ItfProfile(user=new_user, subscribed=self.cleaned_data['subscribe'])
        new_profile.save()
        return new_user
    


class ConnectionsWidget(forms.SelectMultiple):
    template_name = 'formwidgets/select2_multiple.html'

    '''
    def get_context_data(self):
        ctx = super(ConnectionsWidget, self).get_context_data()
        
        #ctx['data_json'] = [{'id': obj[0], 'text': obj[1]} for obj in self.choices]
        return ctx
    '''
        
    def get_context(self, name, value, attrs, *args, **kwargs):
        import pdb
        pdb.set_trace()
        ctx = super(ConnectionsWidget, self).get_context(name, value, attrs)
        ctx['data_json'] = "hi" # json.dumps(choices)
        return ctx
    

#Actual person form definition
class PersonForm(forms.ModelForm):
#    occupations = forms.ModelMultipleChoiceField(Occupation.objects.all(), widget=forms.CheckboxSelectMultiple())
    connections = forms.ModelMultipleChoiceField(Person.objects.all(), widget=ConnectionsWidget())
#    occupations = forms.ModelMultipleChoiceField(Occupation.objects.all(), widget=forms.CheckboxSelectMultiple())
    email = forms.EmailField(widget=forms.EmailInput(attrs={'placeholder': 'john@example.com'}))

#  inlines = [ConnectionFormset, ProductionFormset]
    class Meta:
        model = Person
        widgets = {
            'first_name': forms.TextInput,
            'last_name': forms.TextInput,
            'occupations': forms.CheckboxSelectMultiple
        }
        #exclude = ('connections', 'productions')
      

